public class Event {

    private Kuenstler kuenstler;
    private Ticketkathegorie ticketkathegorie1;
    private Ticketkathegorie ticketkathegorie2;
    private Ticketkathegorie ticketkathegorie3;

    public Event() {
        kuenstler = new Kuenstler();
        ticketkathegorie1 = new Ticketkathegorie();
        ticketkathegorie2 = new Ticketkathegorie();
        ticketkathegorie3 = new Ticketkathegorie();
    }

    public Event(Kuenstler kuenstler, Ticketkathegorie ticketkathegorie1, Ticketkathegorie ticketkathegorie2, Ticketkathegorie ticketkathegorie3) {
        this.kuenstler = kuenstler;
        this.ticketkathegorie1 = ticketkathegorie1;
        this.ticketkathegorie2 = ticketkathegorie2;
        this.ticketkathegorie3 = ticketkathegorie3;
    }

    public void setKuenstler(String bezeichnung, int gage) {
        kuenstler.setGage(gage);
        kuenstler.setBezeichnung(bezeichnung);
    }


    public void setTicketkathegorie(int kathegorie, String bezeichnung, int preis, int anzahlRest) {
        if(kathegorie == 1) {
            setspecificTicketkathegorie(ticketkathegorie1, bezeichnung, preis, anzahlRest);
        }
        else if(kathegorie == 2) {
            setspecificTicketkathegorie(ticketkathegorie2, bezeichnung, preis, anzahlRest);
        }
        else if (kathegorie == 3) {
            setspecificTicketkathegorie(ticketkathegorie3, bezeichnung, preis, anzahlRest);
        }
        else {
            System.out.println("Diese Kathegorie existiert nicht. Geben Sie eine Nummer 1,2 oder 3 an.");
        }
    }
    
    private void setspecificTicketkathegorie(Ticketkathegorie ticketkathegorie, String bezeichnung, int preis, int anzahlRest) {
        ticketkathegorie.setBezeichnung(bezeichnung);
        ticketkathegorie.setPreis(preis);
        ticketkathegorie.setAnzahlRest(anzahlRest);
    }
    

    public void kaufeTicket(int kathegorie, int anzahl) {
        if(kathegorie == 1) {
            kaufAusfuehren(ticketkathegorie1, anzahl);
        }
        else if(kathegorie == 2) {
            kaufAusfuehren(ticketkathegorie2, anzahl);
        }
        else if(kathegorie == 3) {
            kaufAusfuehren(ticketkathegorie3, anzahl);
        }
        else {
            System.out.println("Diese Kathegorie existiert nicht. Geben Sie eine Nummer 1,2 oder 3 an.");
        }
    }
    
    public void kaufAusfuehren(Ticketkathegorie kathegorie, int anzahl) {
        if(kathegorie.kaufen(anzahl)) {
                System.out.println("Kauf von " + anzahl + " Tickets erfolgreich");
            }
            else {
                System.out.println("Kauf fehlgeschlagen, nur " + kathegorie.getAnzahlRest() + " Tickets übrig.");
            }
    }


    public void infoAusgeben() {
        System.out.println("Kuenstler: " + kuenstler.getBezeichnung() + ", Gage: CHF " + kuenstler.getGage());
        int AnzahlVerkauft1 = ticketkathegorie1.getAnzahlVerkauft();
        int AnzahlVerkauft2 = ticketkathegorie2.getAnzahlVerkauft();
        int AnzahlVerkauft3 = ticketkathegorie3.getAnzahlVerkauft();
        int Einnahmen1 = AnzahlVerkauft1 * ticketkathegorie1.getPreis();
        int Einnahmen2 = AnzahlVerkauft2 * ticketkathegorie2.getPreis();
        int Einnahmen3 = AnzahlVerkauft3 * ticketkathegorie3.getPreis();
        int gesamteinnahmen = Einnahmen1 + Einnahmen2 + Einnahmen3;
        System.out.println(ticketkathegorie1.getBezeichnung() + " Tickets: " + AnzahlVerkauft1 + " von " + (AnzahlVerkauft1 + ticketkathegorie1.getAnzahlRest()) + " verkauft, Einnahmen: CHF " + Einnahmen1);
        System.out.println(ticketkathegorie2.getBezeichnung() + " Tickets: " + AnzahlVerkauft2 + " von " + (AnzahlVerkauft2 + ticketkathegorie2.getAnzahlRest()) + " verkauft, Einnahmen: CHF " + Einnahmen2);
        System.out.println(ticketkathegorie3.getBezeichnung() + " Tickets: " + AnzahlVerkauft3 + " von " + (AnzahlVerkauft3 + ticketkathegorie3.getAnzahlRest()) + " verkauft, Einnahmen: CHF " + Einnahmen3);
        System.out.println("Gesamteinnahmen: CHF " + gesamteinnahmen);
        System.out.println("Gewinn: " + (gesamteinnahmen - kuenstler.getGage()));
    }

}

